<template>
    <q-page class="bg-base">
        <DocumentWrapper ref='wrap'>

            <SubContractorFullCard v-if="$q.screen.lg" :subcontractor="subcontractor"
                                   @delete="dialog = true"
            />
            <SubContractorMobile v-else :sub="subcontractor"
                                 @delete="dialog = true"
            />
            <q-dialog v-model="dialog" persistent>
                <DeleteSubcontractorDialog @back="dialog = false" class="bg-base" :subcontractor="subcontractor.principal"/>
            </q-dialog>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Container from "components/Core/Container.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import ListPage from "components/Core/ListPage.vue";
import {SubContractorResponse} from "src/classLibrary/APIModels/core/subContractorResponse";
import MetaData from "components/Entities/MetaData.vue";
import SubContractorMobile from "components/Full/SubContractorMobile.vue";
import SubContractorFullCard from "components/Full/SubContractorFullCard.vue";
import DeleteSubcontractorDialog from "components/Dialog/DeleteSubcontractorDialog.vue";

@Component({
    components: {
        DeleteSubcontractorDialog,
        SubContractorFullCard, SubContractorMobile, MetaData, ListPage, DocumentWrapper, Container
    }
})
export default class SubContractorOverview extends Vue {
    subcontractor: SubContractorResponse | null = null;

    dialog = false;

    routeParams = {
        subId: '',
    }

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    Edit() {

    }

    Delete() {

    }


    async loadSubcontractor() {
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<SubContractorResponse>(`SubContractor/${this.routeParams.subId}`, null, token);
        if (r.isErr()) {
            return this.Wrap.SubmitError(r.unwrapErr())
        }
        this.subcontractor = r.unwrap();
    }


    async init() {
        await this.loadSubcontractor();
    }
}
</script>
